#include "map.h"
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "main.h"

struct write_struct {
  FILE *fptr;
  int mode;
};

int entry_handler(const void *key, size_t size, uintptr_t val, void *usr) {
  struct write_struct *usr2 = (struct write_struct *)usr;

  char *val2 = (char *)val;
  char *key2 = (char *)key;

  if (usr2->mode == 0) {
    fwrite(val2, sizeof(char), strlen(val2), usr2->fptr);
    fwrite(";", sizeof(char), 1, usr2->fptr);
    fwrite(key2, sizeof(char), strlen(key2), usr2->fptr);
    if (key2[strlen(key2) - 1] != '\n') {
      fwrite("\n", sizeof(char), 1, usr2->fptr);
    }
  } else if (usr2->mode == 1) {
    fwrite(key2, sizeof(char), strlen(key2), usr2->fptr);
    if (key2[strlen(key2) - 1] != '\n') {
      fwrite("\n", sizeof(char), 1, usr2->fptr);
    }
  } else  {
    fwrite(key2, sizeof(char), strlen(key2), usr2->fptr);
    fwrite(";", sizeof(char), 1, usr2->fptr);
    fwrite(val2, sizeof(char), strlen(val2), usr2->fptr);
    if (val2[strlen(val2) - 1] != '\n') {
      fwrite("\n", sizeof(char), 1, usr2->fptr);
    }
  }

  return 1;
}

void write_elements(hashmap *m, char *table, int mode) {
  FILE *fptr;

  fptr = fopen(table, "w");

  if (fptr == NULL)
    return;

  struct write_struct writer = {.fptr = fptr, .mode = mode};

  hashmap_iterate(m, entry_handler, (void *)&writer);
  //fwrite("\n", sizeof(char), 1, fptr);

  fclose(fptr);
}

int load_elements(hashmap *m, char *table, int mode) {
  FILE *fptr;

  fptr = fopen(table, "r");

  if (fptr == NULL)
    return 0;

  char *str;
  char *str2;

  int did_something = 0;

  int lines_get = 0;

  while (1) {
    str2 = calloc(MAX_FILE_SIZE, sizeof(char));
    if (!fgets(str2, MAX_FILE_SIZE, fptr)) {
      free(str2);
      break;
    }

    lines_get++;

    str = calloc(strlen(str2) + 1, sizeof(char));
    strcpy(str, str2);
    free(str2);

    did_something = 1;

    if (mode == 1) {
      hashmap_set(m, str, strlen(str) - 1, (uintptr_t)1, 0);
      continue;
    }

    char *combo_o = strstr(str, ";");
    combo_o[0] = '\0';
    combo_o++;

    char *combo = calloc(strlen(combo_o) + 1, sizeof(char));
    strcpy(combo, combo_o);

    if (mode == 3) {
      uintptr_t result;
      hashmap_get(m, str, strlen(str) - 1, &result);

      char *res = (char *)result;

      if (res != 0)
        continue;
    }

    if (mode == 2 || mode == 3) {
      hashmap_set(m, str, strlen(str) - 1, (uintptr_t)combo, 1);
      continue;
    }

    hashmap_set(m, combo, strlen(combo) - 1, (uintptr_t)str, 1);
  }

  if (!did_something) {
    free(str);
  }

  fclose(fptr);

  return did_something;

  // todo: properly free this
}